# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.3.0
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""
Wrapper module containing the Gl_Image_Widget class

This is the FLTK widget in the GL_image_display project:

  https://github.com/dkogan/GL_image_display

It displays an image in an FLTK widget, using OpenGL internally, which gives us
efficient draws and redraws.

The widget is intended to work with the FLTK GUI tookit:

  https://www.fltk.org/

with Python bindings provided by the pyfltk project:

  https://pyfltk.sourceforge.io/
"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _Fl_Gl_Image_Widget
else:
    import _Fl_Gl_Image_Widget

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

import fltk
class Fl_Gl_Image_Widget(fltk.Fl_Gl_Window):
    r"""
    Gl_Image_Widget class: efficient image display in FLTK

    SYNOPSIS

      from fltk import *
      import Fl_Gl_Image_Widget

      w = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
      g = Fl_Gl_Image_Widget.Fl_Gl_Image_Widget(0,0, 800,600)
      w.resizable(w)
      w.end()
      w.show()

      g.update_image(image_filename = 'image.jpg')
      Fl.run()

    This is the FLTK widget in the GL_image_display project:

      https://github.com/dkogan/GL_image_display

    It displays an image in an FLTK widget, using OpenGL internally, which gives us
    efficient draws and redraws.

    The widget is intended to work with the FLTK GUI tookit:

      https://www.fltk.org/

    with Python bindings provided by the pyfltk project:

      https://pyfltk.sourceforge.io/

    """

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self, *args, **kwargs):
        r"""
        __init__(Fl_Gl_Image_Widget self, int x, int y, int w, int h, bool double_buffered=True) -> Fl_Gl_Image_Widget
        Fl_Gl_Image_Widget constructor

        SYNOPSIS

          from fltk import *
          import Fl_Gl_Image_Widget

          w = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
          g = Fl_Gl_Image_Widget.Fl_Gl_Image_Widget(0,0, 800,600)
          w.resizable(w)
          w.end()
          w.show()

          g.update_image(image_filename = 'image.jpg')
          Fl.run()

        The Fl_Gl_Image_Widget is initialized like any other FLTK widget, using the
        sequential arguments: x, y, width, height. The data being displayed is NOT given
        to this method: Fl_Gl_Image_Widget.update_image() needs to be called to provide
        this data

        ARGUMENTS:

        - x: required integer that specifies the x pixel coordinate of the top-left
          corner of the widget

        - y: required integer that specifies the y pixel coordinate of the top-left
          corner of the widget

        - w: required integer that specifies the width of the widget

        - h: required integer that specifies the height of the widget

        - double_buffered: optional boolean, defaulting to True. On some hardware (i915
          for instance) double-buffering causes redrawing bugs (the window sometimes is
          never updated), so disabling double-buffering is a good workaround. In
          general, single-buffering causes redraw flicker, so double-buffering is
          recommended where possible

        """
        if self.__class__ == Fl_Gl_Image_Widget:
            _self = None
        else:
            _self = self
        _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_swiginit(self, _Fl_Gl_Image_Widget.new_Fl_Gl_Image_Widget(_self, *args, **kwargs))

        if len(args) == 5:
        #retain reference to label
            self.my_label = args[-1]
        if self.parent() != None:
        #delegate ownership to C++
            self.this.disown()



    __swig_destroy__ = _Fl_Gl_Image_Widget.delete_Fl_Gl_Image_Widget

    def draw(self, *args, **kwargs):
        r"""
        draw(Fl_Gl_Image_Widget self)
        Fl_Gl_Image_Widget draw() routine

        This is a draw() method that all FLTK widgets have, and works the same way.
        Usually the end user does not need to call this method


        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_draw(self, *args, **kwargs)

    def handle(self, *args, **kwargs):
        r"""
        handle(Fl_Gl_Image_Widget self, int event) -> int
        Event handling() routine

        This is the usual handle() method that all FLTK widgets use to process events.
        Usually the end user does not need to call this method


        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_handle(self, *args, **kwargs)

    def update_image2(self, *args, **kwargs):
        r"""
        update_image2(Fl_Gl_Image_Widget self, int decimation_level=0, bool flip_x=False, bool flip_y=False, char const * image_filename=None, char const * image_data=None) -> bool
        Update the image being displayed in the widget

        SYNOPSIS

          from fltk import *
          import Fl_Gl_Image_Widget

          w = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
          g = Fl_Gl_Image_Widget.Fl_Gl_Image_Widget(0,0, 800,600)
          w.resizable(w)
          w.end()
          w.show()

          g.update_image(image_filename = 'image.jpg')
          Fl.run()

        The data displayed by the widget is providing using this update_image()
        method. This method is given the full-resolution data, subject to any decimation
        specified in decimation_level argument:

        - if decimation_level==0: the given image is displayed at full resolution

        - if decimation_level==1: the given image is displayed at half-resolution

        - if decimation_level==2: the given image is displayed at quarter-resolution

        and so on.

        This method may be called as many times as necessary. The decimation level and
        image dimensions MUST match those given in the first call to this function.

        The data may be passed-in to this method in one of three ways:

        - image_filename: the image is read from a file on disk, with the given
          filename. image_data must be None

        - image_data: the image data is read from the given numpy array. image_filename
          must be None

        - both image_filename and image_data are None: we draw a black image

        An exception is raised on error

        ARGUMENTS

        - image_filename: optional string, specifying the filename containing the image
          to display. Exclusive with image_data

        - image_data: optional numpy array containing the data being displayed. Must
          have dtype=np.uint8. Exclusive with image_filename. The array shape is either

          - (height,width) to pass a grayscale image
          - (height,width,3) to pass a BGR color image

        - decimation_level: optional integer, defaulting to 0. Specifies the resolution
          of the displayed image.

        - flip_x: optional boolean, defaulting to False. Display a left/right mirror of the image

        - flip_y: optional boolean, defaulting to False. Display an up/down  mirror of the image


        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_update_image2(self, *args, **kwargs)

    def set_panzoom(self, *args, **kwargs):
        r"""
        set_panzoom(Fl_Gl_Image_Widget self, double x_centerpixel, double y_centerpixel, double visible_width_pixels) -> bool
        Updates the pan, zoom settings of an image view

        SYNOPSIS

          from fltk import *
          from Fl_Gl_Image_Widget import Fl_Gl_Image_Widget

          class Fl_Gl_Image_Widget_Derived(Fl_Gl_Image_Widget):

              def set_panzoom(self,
                              x_centerpixel, y_centerpixel,
                              visible_width_pixels,
                              panzoom_siblings = True):
                  r'''Pan/zoom the image

                  This is an override of the function to do this: any request to
                  pan/zoom the widget will come here first. panzoom_siblings
                  dispatches any pan/zoom commands to all the widgets, so that they
                  all work in unison.

                  '''
                  if not panzoom_siblings:
                      return super().set_panzoom(x_centerpixel, y_centerpixel,
                                                 visible_width_pixels)

                  # All the widgets should pan/zoom together
                  return               all( w.set_panzoom(x_centerpixel, y_centerpixel,
                                         visible_width_pixels,
                                         panzoom_siblings = False)                                 for w in (widget_image0, widget_image1) )

          window = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
          image0 = Fl_Gl_Image_Widget_Derived(0,  0, 400,600)
          image1 = Fl_Gl_Image_Widget_Derived(400,0, 400,600)
          window.resizable(image)
          window.end()
          window.show()

          image0.update_image(image_filename = 'image0.png')
          image1.update_image(image_filename = 'image1.png')

          Fl.run()

        This is a thin wrapper around the C API function GL_image_display_set_panzoom().
        USUALLY there's no reason to the user to call this: the default
        Fl_Gl_Image_Widget behavior already includes interactive navigation that calls
        this function as needed.

        The primary reason this is available in Python is to allow the user to hook
        these calls in their derived classes to enhance or modify the pan/zoom
        behaviors. The example in the SYNOPSIS above displays two images side by size,
        and pans/zooms them in unison: when the user changes the view in one widget, the
        change is applied to BOTH widgets.

        If any of the given values are Inf or NaN or abs() >= 1e20, we use the
        previously-set value.


        ARGUMENTS

        - x_centerpixel, y_centerpixel: the pixel coordinates of the image to place in
          the center of the viewport. This is the 'pan' setting

        - visible_width_pixels: how many horizontal image pixels should span the
          viewport. This is the 'zoom' setting

        RETURNED VALUE

        None on success. An exception is thrown in case of error (usually, if something
        hasn't been initialized yet or if the input is invalid).


        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_set_panzoom(self, *args, **kwargs)

    def map_pixel_viewport_from_image(self, *args, **kwargs):
        r"""
        map_pixel_viewport_from_image(Fl_Gl_Image_Widget self, double x) -> bool
        Compute viewport pixel coords from image pixel coords

        SYNOPSIS

          from fltk import *
          from Fl_Gl_Image_Widget import Fl_Gl_Image_Widget

          class Fl_Gl_Image_Widget_Derived(Fl_Gl_Image_Widget):

              def handle(self, event):
                  if event == FL_ENTER:
                      return 1
                  if event == FL_MOVE:
                      try:
                          qi = self.map_pixel_image_from_viewport( (Fl.event_x(),Fl.event_y()), )
                          status.value(f'{qi[0]:.2f},{qi[1]:.2f}')
                      except:
                          status.value('')
                  return super().handle(event)

          window = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
          image  = Fl_Gl_Image_Widget_Derived(0,0, 800,580)
          status = Fl_Output(0,580,800,20)
          window.resizable(image)
          window.end()
          window.show()

          image.update_image(image_filename = 'image.png')

          Fl.run()

        The map_pixel_image_from_viewport() and map_pixel_viewport_from_image()
        functions map between the coordinates of the viewport and the image being
        displayed (original image; prior to any decimation). This is useful to implement
        user interaction methods that respond to user clicks or draw overlays.

        The inputs and outputs both contain floating-point pixels. The map is linear, so
        no out-of-bounds checking is done on the input or on the output: negative values
        can be ingested or output.

        An exception is thrown in case of error (usually, if something hasn't been
        initialized yet or if the input is invalid).

        ARGUMENTS

        - qin: the input pixel coordinate. This is an iterable of length two that
          contains two floating-point values. This may be a numpy array of a tuple or
          a list, for instance.

        RETURNED VALUE

        A length-2 tuple containing the mapped pixel coordinate

        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_map_pixel_viewport_from_image(self, *args, **kwargs)

    def map_pixel_image_from_viewport(self, *args, **kwargs):
        r"""
        map_pixel_image_from_viewport(Fl_Gl_Image_Widget self, double x) -> bool
        Compute image pixel coords from viewport pixel coords

        SYNOPSIS

          from fltk import *
          from Fl_Gl_Image_Widget import Fl_Gl_Image_Widget

          class Fl_Gl_Image_Widget_Derived(Fl_Gl_Image_Widget):

              def handle(self, event):
                  if event == FL_ENTER:
                      return 1
                  if event == FL_MOVE:
                      try:
                          qi = self.map_pixel_image_from_viewport( (Fl.event_x(),Fl.event_y()), )
                          status.value(f'{qi[0]:.2f},{qi[1]:.2f}')
                      except:
                          status.value('')
                  return super().handle(event)

          window = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
          image  = Fl_Gl_Image_Widget_Derived(0,0, 800,580)
          status = Fl_Output(0,580,800,20)
          window.resizable(image)
          window.end()
          window.show()

          image.update_image(image_filename = 'image.png')

          Fl.run()

        The map_pixel_image_from_viewport() and map_pixel_viewport_from_image()
        functions map between the coordinates of the viewport and the image being
        displayed (original image; prior to any decimation). This is useful to implement
        user interaction methods that respond to user clicks or draw overlays.

        The inputs and outputs both contain floating-point pixels. The map is linear, so
        no out-of-bounds checking is done on the input or on the output: negative values
        can be ingested or output.

        An exception is thrown in case of error (usually, if something hasn't been
        initialized yet or if the input is invalid).

        ARGUMENTS

        - qin: the input pixel coordinate. This is an iterable of length two that
          contains two floating-point values. This may be a numpy array of a tuple or
          a list, for instance.

        RETURNED VALUE

        A length-2 tuple containing the mapped pixel coordinate

        """
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_map_pixel_image_from_viewport(self, *args, **kwargs)

    def _set_lines(self, *args, **kwargs):
        r"""_set_lines(Fl_Gl_Image_Widget self, GL_image_display_line_segments_t const * line_segment_sets) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget__set_lines(self, *args, **kwargs)

    def process_mousewheel_zoom(self, *args, **kwargs):
        r"""process_mousewheel_zoom(Fl_Gl_Image_Widget self, double dy, double event_x, double event_y, double viewport_width, double viewport_height) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_process_mousewheel_zoom(self, *args, **kwargs)

    def process_mousewheel_pan(self, *args, **kwargs):
        r"""process_mousewheel_pan(Fl_Gl_Image_Widget self, double dx, double dy, double viewport_width, double viewport_height) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_process_mousewheel_pan(self, *args, **kwargs)

    def process_mousedrag_pan(self, *args, **kwargs):
        r"""process_mousedrag_pan(Fl_Gl_Image_Widget self, double dx, double dy, double viewport_width, double viewport_height) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_process_mousedrag_pan(self, *args, **kwargs)

    def process_keyboard_panzoom_orig(self, *args, **kwargs):
        r"""process_keyboard_panzoom_orig(Fl_Gl_Image_Widget self) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_process_keyboard_panzoom_orig(self, *args, **kwargs)

    def process_keyboard_panzoom(self, *args, **kwargs):
        r"""process_keyboard_panzoom(Fl_Gl_Image_Widget self) -> bool"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_process_keyboard_panzoom(self, *args, **kwargs)
    def __disown__(self):
        self.this.disown()
        _Fl_Gl_Image_Widget.disown_Fl_Gl_Image_Widget(self)
        return weakref.proxy(self)

    def on_insert(self, *args, **kwargs):
        r"""on_insert(Fl_Gl_Image_Widget self, Fl_Widget arg0, int arg1) -> int"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_on_insert(self, *args, **kwargs)

    def on_move(self, *args, **kwargs):
        r"""on_move(Fl_Gl_Image_Widget self, int arg0, int arg1) -> int"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_on_move(self, *args, **kwargs)

    def on_remove(self, *args, **kwargs):
        r"""on_remove(Fl_Gl_Image_Widget self, int arg0)"""
        return _Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_on_remove(self, *args, **kwargs)

# Register Fl_Gl_Image_Widget in _Fl_Gl_Image_Widget:
_Fl_Gl_Image_Widget.Fl_Gl_Image_Widget_swigregister(Fl_Gl_Image_Widget)

def set_lines(self, *args):
    """Compute image pixel coords from viewport pixel coords

SYNOPSIS

  from fltk import *
  from Fl_Gl_Image_Widget import Fl_Gl_Image_Widget

  class Fl_Gl_Image_Widget_Derived(Fl_Gl_Image_Widget):

      def handle(self, event):
          if event == FL_PUSH:
              try:
                  qv = (Fl.event_x(),Fl.event_y())
                  qi = \
                      np.array( \
                        self.map_pixel_image_from_viewport(qv),
                        dtype=float ).round()

                  x,y = q
                  self.set_lines( dict(points =
                                       np.array( (((x - 50, y),
                                                   (x + 50, y)),
                                                  ((x,      y - 50),
                                                   (x,      y + 50))),
                                                 dtype=np.float32),
                                       color_rgb = np.array((1,0,0),
                                                            dtype=np.float32) ))
              except:
                  self.set_lines()
              return 1

          return super().handle(event)

  window = Fl_Window(800, 600, 'Image display with Fl_Gl_Image_Widget')
  image  = Fl_Gl_Image_Widget_Derived(0,0, 800,600)
  window.resizable(image)
  window.end()
  window.show()

  image.update_image(image_filename = 'image.png')

  Fl.run()

Updates the set of lines we draw as an overlay on top of the image. The
hierarchy:

- Each SET of lines is drawn with the same color, and consists of separate line
  SEGMENTS

- Each line SEGMENT connects two independent points (x0,y0) and (x1,y1) in image
  pixel coordinates.

Each call looks like

  set_lines( SET, SET, SET, ... )

Where each SET is

  dict(points    = POINTS,
       color_rgb = COLOR)

- POINTS is a numpy array of shape (Nsegments,2,2) where each innermost row is
  (x,y). This array must have dtype=np.float32 and must be stored contiguously

- COLOR is the (red,green,blue) tuple to use for the line. This is a numpy array
  of shape (3,). This array must have dtype=np.float32 and must be stored
  contiguously. The color is passed directly to OpenGL, and uses values in [0,1]

RETURNED VALUE

None on success. An exception is thrown in case of error (usually, if something
hasn't been initialized yet or if the input is invalid).

"""
    return self._set_lines(args)

Fl_Gl_Image_Widget.set_lines = set_lines


# In C++ update_image() is the legacy function and update_image2() is the "real" function.
# Here I use the "update_image2" wrapping for both names
Fl_Gl_Image_Widget.update_image = Fl_Gl_Image_Widget.update_image2


